#NoTrayIcon

#include <GDIP.au3>
#include <Misc.au3>
#include <GUIImageList.au3>
#include <GUIToolbar.au3>
#include <ModernMenuRaw.au3>
#include <String.au3>
#include <Array.au3>

Dim $Position[2]
Dim $Position2[2]
Dim $Grafiken[1][30]
Dim $Zwischenspeicher[31]
Dim $Button[18]
Dim $Bilder[1][2]
Dim $Programm[4]
Dim $Zaehler[12]
Dim $Steuerung[30]

Global $Hauptzaehler = 0
Global $Bildzaehler = 0
Global $Typ = "DrawLine"
Global $Speicherpfad = ""
Global $Bilddatei1 = "IconLibrary1.icl"
Global $Bilddatei2 = "IconLibrary3.icl"
Global $Bilddatei3 = "IconLibrary2.icl"
Global $String, $Font, $Size, $Format, $Bild, $Msg, $Sichtbar
Global $Aktuell = 0

Global Const $GRAPHIC_TYPE = 0
Global Const $GRAPHIC_X1 = 1
Global Const $GRAPHIC_Y1 = 2
Global Const $GRAPHIC_X2 = 3
Global Const $GRAPHIC_Y2 = 4
Global Const $GRAPHIC_WIDTH = 5
Global Const $GRAPHIC_HEIGHT = 6
Global Const $GRAPHIC_PENCOLOR = 7
Global Const $GRAPHIC_PENWIDTH = 8
Global Const $GRAPHIC_BRUSHCOLOR = 9
Global Const $GRAPHIC_STARTANGLE = 10
Global Const $GRAPHIC_SWEEPANGLE = 11
Global Const $GRAPHIC_X3 = 12
Global Const $GRAPHIC_Y3 = 13
Global Const $GRAPHIC_X4 = 14
Global Const $GRAPHIC_Y4 = 15
Global Const $GRAPHIC_STRING = 16
Global Const $GRAPHIC_FONT = 17
Global Const $GRAPHIC_SIZE = 18
Global Const $GRAPHIC_FORMAT = 19
Global Const $GRAPHIC_IMAGE = 20
Global Const $GRAPHIC_PATH = 21
Global Const $GRAPHIC_ITEM = 22
Global Const $GRAPHIC_NAME = 23

_SetMenuBkColor(0xFFFFFF)
_SetMenuIconBkColor(0xFFFFFF)
_SetMenuTextColor(0x000000)
_SetMenuSelectBkColor(0x999999)
_SetMenuSelectRectColor(0x999999)
_SetMenuSelectTextColor(0xFFFFFF)

$Button[0] = "Neu()"
$Button[1] = "Oeffnen()"
$Button[2] = "Speichern()"
$Button[3] = ")"
$Button[4] = "Starten()"
$Button[5] = 'Assign("Typ","DrawLine")'
$Button[6] = 'Assign("Typ","DrawRect")'
$Button[7] = 'Assign("Typ","DrawArc")'
$Button[8] = 'Assign("Typ","DrawBezier")'
$Button[9] = 'Assign("Typ","DrawEllipse")'
$Button[10] = 'Bild("DrawImage")'
$Button[11] = 'Bild("DrawImageRect")'
$Button[12] = 'Assign("Typ","DrawPie")'
$Button[13] = 'Text()'
$Button[14] = "_"
$Button[15] = 'Assign("Typ","FillEllipse")'
$Button[16] = 'Assign("Typ","FillPie")'
$Button[17] = 'Assign("Typ","FillRect")'

$Programm[0] = "Example"
$Programm[1] = 700
$Programm[2] = 500
$Programm[3] = "0xFFFFFFFF"

DllCall("uxtheme.dll", "none", "SetThemeAppProperties", "int", 5)

$Form_GDI_Editor = GUICreate("GDI Editor", @DesktopWidth - 6, 53, 0, 0)
$Menu_Datei = GUICtrlCreateMenu("Datei")
$MenuItem_Neu = _GUICtrlCreateODMenuItem("Neu", $Menu_Datei, $Bilddatei1, 2)
$MenuItem_Oeffnen = _GUICtrlCreateODMenuItem("ffnen", $Menu_Datei, $Bilddatei1, 3)
$MenuItem_Speichern = _GUICtrlCreateODMenuItem("Speichern", $Menu_Datei, $Bilddatei1, 4)
$MenuItem_Speichern_Unter = _GUICtrlCreateODMenuItem("Speichern Unter", $Menu_Datei)
_GUICtrlCreateODMenuItem("", $Menu_Datei)
$MenuItem_Beenden = _GUICtrlCreateODMenuItem("Beenden", $Menu_Datei, $Bilddatei1, 5)
$Menu_Ansicht = GUICtrlCreateMenu("Ansicht")
$MenuItem_Objektliste = _GUICtrlCreateODMenuItem("Objektliste", $Menu_Ansicht)
GUICtrlSetState(-1, 1)
$MenuItem_Objektinspektor = _GUICtrlCreateODMenuItem("Objektinspektor", $Menu_Ansicht)
GUICtrlSetState(-1, 1)
$MenuItem_Quelltext = _GUICtrlCreateODMenuItem("Quelltext", $Menu_Ansicht)
GUICtrlSetState(-1, 1)
$MenuItem_Konsole = _GUICtrlCreateODMenuItem("Konsole", $Menu_Ansicht)
GUICtrlSetState(-1, 1)
$MenuItem_Vorgabe = _GUICtrlCreateODMenuItem("Vorgabe", $Menu_Ansicht)
GUICtrlSetState(-1, 1)
$MenuItem_Werkzeuge = GUICtrlCreateMenu("Werkzeuge")
$MenuItem_Starten = _GUICtrlCreateODMenuItem("Starten", $MenuItem_Werkzeuge, $Bilddatei1, 10)
$ImageList = _GUIImageList_Create(24, 24, 5)
_GUIImageList_AddIcon($ImageList, $Bilddatei2, 0, True)
_GUIImageList_AddIcon($ImageList, $Bilddatei2, 1, True)
_GUIImageList_AddIcon($ImageList, $Bilddatei2, 2, True)
_GUIImageList_AddIcon($ImageList, $Bilddatei2, 3, True)
_GUIImageList_AddIcon($ImageList, $Bilddatei2, 4, True)
_GUIImageList_AddIcon($ImageList, $Bilddatei2, 5, True)
_GUIImageList_AddIcon($ImageList, $Bilddatei2, 10, True)
_GUIImageList_AddIcon($ImageList, $Bilddatei2, 7, True)
_GUIImageList_AddIcon($ImageList, $Bilddatei2, 6, True)
_GUIImageList_AddIcon($ImageList, $Bilddatei2, 8, True)
_GUIImageList_AddIcon($ImageList, $Bilddatei2, 16, True)
_GUIImageList_AddIcon($ImageList, $Bilddatei2, 17, True)
_GUIImageList_AddIcon($ImageList, $Bilddatei2, 9, True)
_GUIImageList_AddIcon($ImageList, $Bilddatei2, 11, True)
_GUIImageList_AddIcon($ImageList, $Bilddatei2, 12, True)
_GUIImageList_AddIcon($ImageList, $Bilddatei2, 13, True)
_GUIImageList_AddIcon($ImageList, $Bilddatei2, 14, True)
_GUIImageList_AddIcon($ImageList, $Bilddatei2, 15, True)
$ToolBar = _GUICtrlToolbar_Create($Form_GDI_Editor)
_GUICtrlToolbar_SetImageList($ToolBar, $ImageList)
_GUICtrlToolbar_AddButton($ToolBar, 0, 0, 0)
_GUICtrlToolbar_AddButton($ToolBar, 1, 1, 0)
_GUICtrlToolbar_AddButton($ToolBar, 2, 2, 0)
_GUICtrlToolbar_AddButtonSep($ToolBar)
_GUICtrlToolbar_AddButton($ToolBar, 3, 3, 0)
_GUICtrlToolbar_AddButton($ToolBar, 4, 4, 0)
_GUICtrlToolbar_AddButtonSep($ToolBar)
_GUICtrlToolbar_AddButton($ToolBar, 5, 5, 0)
_GUICtrlToolbar_AddButton($ToolBar, 6, 6, 0)
_GUICtrlToolbar_AddButton($ToolBar, 7, 7, 0)
_GUICtrlToolbar_AddButton($ToolBar, 8, 8, 0)
_GUICtrlToolbar_AddButton($ToolBar, 9, 9, 0)
_GUICtrlToolbar_AddButton($ToolBar, 10, 10, 0)
_GUICtrlToolbar_AddButton($ToolBar, 11, 11, 0)
_GUICtrlToolbar_AddButton($ToolBar, 12, 12, 0)
_GUICtrlToolbar_AddButton($ToolBar, 13, 13, 0)
_GUICtrlToolbar_AddButton($ToolBar, 14, 14, 0)
_GUICtrlToolbar_AddButton($ToolBar, 15, 15, 0)
_GUICtrlToolbar_AddButton($ToolBar, 16, 16, 0)
_GUICtrlToolbar_AddButton($ToolBar, 17, 17, 0)
GUISetState()

$Form_Form = GUICreate("Form", $Programm[1], $Programm[2], 190, 92, -1, -1, $Form_GDI_Editor)
_GDIPlus_Startup()
$Grafik = _GDIPlus_GraphicsCreateFromHWND($Form_Form)
$Bitmap = _GDIPlus_BitmapCreateFromGraphics($Programm[1], $Programm[2], $Grafik)
$Buffer = _GDIPlus_ImageGetGraphicsContext($Bitmap)
$Pen = _GDIPlus_PenCreate()
$Brush = _GDIPlus_BrushCreateSolid()
GUISetState()

$Form_Objektinspektor = GUICreate("Objektinspektor", 180, 629, 0, 358, -1, BitOR(0x00000080, 0x00000100), $Form_GDI_Editor)
GUISetFont(7, 400, 0, "Verdana")
GUICtrlCreateLabel("Name", 6, 11, 68, 16)
GUICtrlCreateLabel("Typ", 6, 35, 68, 16)
GUICtrlCreateLabel("X1", 6, 59, 68, 16)
GUICtrlCreateLabel("Y1", 6, 83, 68, 16)
GUICtrlCreateLabel("Breite", 6, 107, 68, 16)
GUICtrlCreateLabel("Hhe", 6, 131, 68, 16)
GUICtrlCreateLabel("Stiftfarbe", 6, 155, 68, 16)
GUICtrlCreateLabel("Stiftbreite", 6, 179, 68, 16)
GUICtrlCreateLabel("Fllfarbe", 6, 203, 68, 16)
GUICtrlCreateLabel("Startwinkel", 6, 227, 68, 16)
GUICtrlCreateLabel("Pfeilung", 6, 251, 68, 16)
GUICtrlCreateLabel("X2", 6, 275, 68, 16)
GUICtrlCreateLabel("Y2", 6, 299, 68, 16)
GUICtrlCreateLabel("X3", 6, 323, 68, 16)
GUICtrlCreateLabel("Y3", 6, 347, 68, 16)
GUICtrlCreateLabel("X4", 6, 371, 68, 16)
GUICtrlCreateLabel("Y4", 6, 395, 68, 16)
GUICtrlCreateLabel("Text", 6, 539, 68, 16)
GUICtrlCreateLabel("Schrift", 6, 419, 68, 16)
GUICtrlCreateLabel("Schriftgre", 6, 443, 68, 16)
GUICtrlCreateLabel("Format", 6, 467, 68, 16)
GUICtrlCreateLabel("Bild", 6, 491, 68, 16)
GUICtrlCreateLabel("Bildpfad", 6, 515, 68, 16)
$Steuerung[$GRAPHIC_NAME] = GUICtrlCreateInput("", 72, 8, 105, 20, 2048)
$Steuerung[$GRAPHIC_TYPE] = GUICtrlCreateInput("", 72, 32, 105, 20, 2048)
$Steuerung[$GRAPHIC_X1] = GUICtrlCreateInput("", 72, 56, 105, 20)
$Steuerung[$GRAPHIC_Y1] = GUICtrlCreateInput("", 72, 80, 105, 20)
$Steuerung[$GRAPHIC_WIDTH] = GUICtrlCreateInput("", 72, 104, 105, 20)
$Steuerung[$GRAPHIC_HEIGHT] = GUICtrlCreateInput("", 72, 128, 105, 20)
$Steuerung[$GRAPHIC_PENCOLOR] = GUICtrlCreateInput("", 72, 152, 89, 20)
$Steuerung[$GRAPHIC_PENWIDTH] = GUICtrlCreateInput("", 72, 176, 105, 20)
$Steuerung[$GRAPHIC_BRUSHCOLOR] = GUICtrlCreateInput("", 72, 200, 89, 20)
$Steuerung[$GRAPHIC_STARTANGLE] = GUICtrlCreateInput("", 72, 224, 105, 20)
$Steuerung[$GRAPHIC_SWEEPANGLE] = GUICtrlCreateInput("", 72, 248, 105, 20)
$Steuerung[$GRAPHIC_X2] = GUICtrlCreateInput("", 72, 272, 105, 20)
$Steuerung[$GRAPHIC_Y2] = GUICtrlCreateInput("", 72, 296, 105, 20)
$Steuerung[$GRAPHIC_X3] = GUICtrlCreateInput("", 72, 320, 105, 20)
$Steuerung[$GRAPHIC_Y3] = GUICtrlCreateInput("", 72, 344, 105, 20)
$Steuerung[$GRAPHIC_X4] = GUICtrlCreateInput("", 72, 368, 105, 20)
$Steuerung[$GRAPHIC_Y4] = GUICtrlCreateInput("", 72, 392, 105, 20)
$Steuerung[$GRAPHIC_FONT] = GUICtrlCreateCombo("Arial", 72, 416, 105, 25, 0x3)
GUICtrlSetData(-1, "Courier New|Lucida Console|Tahoma|Times New Roman|Verdana|Trebuchet MS|Georgia|Comic Sans MS")
$Steuerung[$GRAPHIC_SIZE] = GUICtrlCreateInput("", 72, 440, 105, 20)
$Steuerung[$GRAPHIC_FORMAT] = GUICtrlCreateCombo("0x0001", 72, 464, 105, 25, 0x3)
GUICtrlSetData(-1, "0x0001|0x0002|0x0004|0x0020|0x0400|0x0800|0x1000|0x2000|0x4000")
$Steuerung[$GRAPHIC_IMAGE] = GUICtrlCreateInput("", 72, 488, 105, 20, 2048)
$Steuerung[$GRAPHIC_PATH] = GUICtrlCreateInput("", 72, 512, 105, 20, 2048)
$Steuerung[$GRAPHIC_STRING] = GUICtrlCreateEdit("", 72, 536, 105, 89)
GUICtrlCreateUpdown($Steuerung[$GRAPHIC_X1])
GUICtrlCreateUpdown($Steuerung[$GRAPHIC_Y1])
GUICtrlCreateUpdown($Steuerung[$GRAPHIC_WIDTH])
GUICtrlCreateUpdown($Steuerung[$GRAPHIC_HEIGHT])
GUICtrlCreateUpdown($Steuerung[$GRAPHIC_PENWIDTH])
GUICtrlCreateUpdown($Steuerung[$GRAPHIC_STARTANGLE])
GUICtrlCreateUpdown($Steuerung[$GRAPHIC_SWEEPANGLE])
GUICtrlCreateUpdown($Steuerung[$GRAPHIC_X2])
GUICtrlCreateUpdown($Steuerung[$GRAPHIC_Y2])
GUICtrlCreateUpdown($Steuerung[$GRAPHIC_X3])
GUICtrlCreateUpdown($Steuerung[$GRAPHIC_Y3])
GUICtrlCreateUpdown($Steuerung[$GRAPHIC_X4])
GUICtrlCreateUpdown($Steuerung[$GRAPHIC_Y4])
GUICtrlCreateUpdown($Steuerung[$GRAPHIC_SIZE])
$Button_Stiftfarbe = GUICtrlCreateButton("", 161, 152, 16, 18)
$Button_Fuellfarbe = GUICtrlCreateButton("", 161, 200, 16, 18)
For $a = 0 To UBound($Steuerung) - 1
	GUICtrlSetState($Steuerung[$a], 128)
Next
GUISetState()

$Form_Vorgabe = GUICreate("Vorgabe", 146, 74, @DesktopWidth - 758, 84, -1, BitOR(0x00000080, 0x00000100), $Form_GDI_Editor)
GUISetFont(10, 400, 0, "Verdana")
$Input_Farbe = GUICtrlCreateInput("0xFF000000", 8, 8, 104, 24)
$Input_Stiftbreite = GUICtrlCreateInput("1", 8, 40, 129, 24)
GUICtrlCreateUpdown($Input_Stiftbreite)
$Button_Farbe = GUICtrlCreateButton("", 112, 8, 25, 25)
GUISetState()

$Form_Objektliste = GUICreate("Objektliste", 180, 250, 0, 84, -1, BitOR(0x00000080, 0x00000100), $Form_GDI_Editor)
GUISetFont(10, 400, 0, "Verdana")
$TreeView_Objektliste = GUICtrlCreateTreeView(0, 0, 180, 250)
$ContextMenu_Objektliste = GUICtrlCreateContextMenu($TreeView_Objektliste)
$MenuItem_ObjektAusschneiden = _GUICtrlCreateODMenuItem("Objekt Ausschneiden", $ContextMenu_Objektliste, $Bilddatei1, 6)
$MenuItem_ObjektKopieren = _GUICtrlCreateODMenuItem("Objekt Kopieren", $ContextMenu_Objektliste, $Bilddatei1, 7)
$MenuItem_ObjektEinfuegen = _GUICtrlCreateODMenuItem("Objekt Einfgen", $ContextMenu_Objektliste, $Bilddatei1, 8)
$MenuItem_ObjektLoeschen = _GUICtrlCreateODMenuItem("Objekt Lschen", $ContextMenu_Objektliste, $Bilddatei1, 12)
GUICtrlSetState($MenuItem_ObjektAusschneiden, 128)
GUICtrlSetState($MenuItem_ObjektKopieren, 128)
GUICtrlSetState($MenuItem_ObjektEinfuegen, 128)
GUICtrlSetState($MenuItem_ObjektLoeschen, 128)
GUISetState()

$Form_Quelltext = GUICreate("Quelltext", 600, 630, @DesktopWidth - 606, 84, -1, -1, $Form_GDI_Editor)
GUISetFont(10, 400, 0, "Verdana")
$Edit_Quelltext = GUICtrlCreateEdit("", 0, 0, 600, 630)
GUISetState()

$Form_Konsole = GUICreate("Konsole", 600, 100, @DesktopWidth - 606, 744, -1, BitOR(0x00000080, 0x00000100), $Form_GDI_Editor)
GUISetFont(10, 400, 0, "Verdana")
$Edit_Konsole = GUICtrlCreateEdit("", 0, 0, 600, 100)
GUISetState()

$Timer = TimerInit()
While True
	$Msg = GUIGetMsg()
	Switch $Msg
		Case -3
			ExitLoop
		Case $MenuItem_Beenden
			ExitLoop
		Case $MenuItem_Objektinspektor
			ZeigenVerstecken($Form_Objektinspektor, GUICtrlRead($MenuItem_Objektinspektor), $MenuItem_Objektinspektor)
		Case $MenuItem_Objektliste
			ZeigenVerstecken($Form_Objektliste, GUICtrlRead($MenuItem_Objektliste), $MenuItem_Objektliste)
		Case $MenuItem_Konsole
			ZeigenVerstecken($Form_Konsole, GUICtrlRead($MenuItem_Konsole), $MenuItem_Konsole)
		Case $MenuItem_Quelltext
			ZeigenVerstecken($Form_Quelltext, GUICtrlRead($MenuItem_Quelltext), $MenuItem_Quelltext)
		Case $MenuItem_Vorgabe
			ZeigenVerstecken($Form_Vorgabe, GUICtrlRead($MenuItem_Vorgabe), $MenuItem_Vorgabe)
		Case $MenuItem_Starten
			Starten()
		Case $MenuItem_Neu
			Neu()
		Case $MenuItem_Oeffnen
			Oeffnen()
		Case $MenuItem_Speichern
			Speichern()
		Case $MenuItem_Speichern_Unter
			SpeichernUnter()
		Case $MenuItem_ObjektAusschneiden
			ObjektAusschneiden(GUICtrlRead($TreeView_Objektliste, 1))
		Case $MenuItem_ObjektKopieren
			ObjektKopieren(GUICtrlRead($TreeView_Objektliste, 1))
		Case $MenuItem_ObjektEinfuegen
			ObjektEinfuegen()
		Case $MenuItem_ObjektLoeschen
			ObjektLoeschen(GUICtrlRead($TreeView_Objektliste, 1))
		Case $Button_Farbe
			GUICtrlSetData($Input_Farbe, Farbe(GUICtrlRead($Input_Farbe)))
		Case $Button_Stiftfarbe
			GUICtrlSetData($Steuerung[$GRAPHIC_PENCOLOR], Farbe(GUICtrlRead($Steuerung[$GRAPHIC_PENCOLOR])))
			$Grafiken[$Aktuell][$GRAPHIC_PENCOLOR] = GUICtrlRead($Steuerung[$GRAPHIC_PENCOLOR])
		Case $Button_Fuellfarbe
			GUICtrlSetData($Steuerung[$GRAPHIC_BRUSHCOLOR], Farbe(GUICtrlRead($Steuerung[$GRAPHIC_BRUSHCOLOR])))
			$Grafiken[$Aktuell][$GRAPHIC_BRUSHCOLOR] = GUICtrlRead($Steuerung[$GRAPHIC_BRUSHCOLOR])
	EndSwitch
	For $i = 0 To UBound($Steuerung) - 1
		If $Msg = $Steuerung[$i] Then
			If GUICtrlRead($Steuerung[$i]) <> "" Then
				$Grafiken[$Aktuell][$i] = GUICtrlRead($Steuerung[$i])
				If GUICtrlRead($Edit_Quelltext) <> Quelltext() Then GUICtrlSetData($Edit_Quelltext, Quelltext())
			EndIf
		EndIf
	Next
	If WinActive("Konsole") Then
		If _IsPressed("0D") = 1 Then
			$Befehl = GUICtrlRead($Edit_Konsole)
			$Befehl = StringSplit($Befehl, @CRLF)
			$StringSplit = StringSplit($Befehl[$Befehl[0] - 2], "=")
			Switch $StringSplit[1]
				Case "title"
					$Programm[0] = $StringSplit[2]
				Case "width"
					$Programm[1] = $StringSplit[2]
					FormAendern()
				Case "height"
					$Programm[2] = $StringSplit[2]
					FormAendern()
				Case "color"
					$Programm[3] = $StringSplit[2]
				Case "graphics"
					_ArrayDisplay($Grafiken, "GDI Editor")
				Case "savetofile"
					_GDIPlus_ImageSaveToFile($Bitmap, $StringSplit[2])
				Case "run"
					Starten()
				Case "new"
					Neu()
				Case "open"
					Oeffnen()
				Case "save"
					Speichern()
				Case "saveas"
					SpeichernUnter()
				Case "copy"
					ClipPut(Quelltext())
				Case "exit"
					ExitLoop
			EndSwitch
		EndIf
		If GUICtrlRead($Edit_Quelltext) <> Quelltext() Then GUICtrlSetData($Edit_Quelltext, Quelltext())
	EndIf
	If Int(TimerDiff($Timer)) > 80 Then
		For $i = 0 To 4
			If _GUICtrlToolbar_IsButtonPressed($ToolBar, $i) = True Then Execute($Button[$i])
		Next
		$Timer = TimerInit()
	EndIf
	For $i = 5 To UBound($Button) - 1
		If _GUICtrlToolbar_IsButtonPressed($ToolBar, $i) = True Then Execute($Button[$i])
	Next
	_GDIPlus_GraphicsClear($Buffer, $Programm[3])
	If _IsPressed(1) = 1 And WinActive("Form") Then
		$Position = GUIGetCursorInfo($Form_Form)
		$PENCOLOR = GUICtrlRead($Input_Farbe)
		$PENWIDTH = GUICtrlRead($Input_Stiftbreite)
		$BRUSHCOLOR = GUICtrlRead($Input_Farbe)
		$STARTANGLE = 90
		$SWEEPANGLE = 230
		Dim $Points[4][2]
		$q = -1
		While _IsPressed(1) = 1
			_GDIPlus_GraphicsClear($Buffer, $Programm[3])
			$Position2 = GUIGetCursorInfo($Form_Form)
			If _IsPressed(25) = 1 Then $STARTANGLE += 1
			If _IsPressed(27) = 1 Then $STARTANGLE -= 1
			If _IsPressed(26) = 1 Then $SWEEPANGLE += 1
			If _IsPressed(28) = 1 Then $SWEEPANGLE -= 1
			If _IsPressed(11) = 1 Then $Position2[1] = $Position2[0] - $Position[0] + $Position[1]
			If _IsPressed(21) = 1 Then $PENWIDTH += 1
			If _IsPressed(22) = 1 And $PENWIDTH <> 1 Then $PENWIDTH -= 1
			Malen()
			_GDIPlus_PenSetColor($Pen, $PENCOLOR)
			_GDIPlus_PenSetWidth($Pen, $PENWIDTH)
			_GDIPlus_BrushSetFillColor($Brush, $BRUSHCOLOR)
			Switch $Typ
				Case "DrawLine"
					_GDIPlus_GraphicsDrawLine($Buffer, $Position[0], $Position[1], $Position2[0], $Position2[1], $Pen)
				Case "DrawRect"
					_GDIPlus_GraphicsDrawRect($Buffer, $Position[0], $Position[1], $Position2[0] - $Position[0], $Position2[1] - $Position[1], $Pen)
				Case "FillRect"
					_GDIPlus_GraphicsFillRect($Buffer, $Position[0], $Position[1], $Position2[0] - $Position[0], $Position2[1] - $Position[1], $Brush)
				Case "DrawEllipse"
					_GDIPlus_GraphicsDrawEllipse($Buffer, $Position[0], $Position[1], $Position2[0] - $Position[0], $Position2[1] - $Position[1], $Pen)
				Case "FillEllipse"
					_GDIPlus_GraphicsFillEllipse($Buffer, $Position[0], $Position[1], $Position2[0] - $Position[0], $Position2[1] - $Position[1], $Brush)
				Case "DrawPie"
					_GDIPlus_GraphicsDrawPie($Buffer, $Position[0], $Position[1], $Position2[0] - $Position[0], $Position2[1] - $Position[1], $STARTANGLE, $SWEEPANGLE, $Pen)
				Case "FillPie"
					_GDIPlus_GraphicsFillPie($Buffer, $Position[0], $Position[1], $Position2[0] - $Position[0], $Position2[1] - $Position[1], $STARTANGLE, $SWEEPANGLE, $Brush)
				Case "DrawArc"
					_GDIPlus_GraphicsDrawArc($Buffer, $Position[0], $Position[1], $Position2[0] - $Position[0], $Position2[1] - $Position[1], $STARTANGLE, $SWEEPANGLE, $Pen)
				Case "DrawBezier"
					If _IsPressed(2) = 1 Then
						$q += 1
						$Points[$q][0] = $Points[$q][0] + $Position2[0]
						$Points[$q][1] = $Position2[1]
						If $q = 3 Then ExitLoop
						ToolTip($q)
						Sleep(200)
					EndIf
					_GDIPlus_GraphicsDrawBezier($Buffer, $Points[0][0], $Points[0][1], $Points[1][0], $Points[1][1], $Points[2][0], $Points[2][1], $Points[3][0], $Points[3][1], $Pen)
				Case "DrawString"
					_GDIPlus_GraphicsDrawString($Buffer, $String, $Position2[0], $Position2[1], $Font, $Size, $Format)
				Case "DrawImage"
					_GDIPlus_GraphicsDrawImage($Buffer, $Bild, $Position2[0], $Position2[1])
				Case "DrawImageRect"
					_GDIPlus_GraphicsDrawImageRect($Buffer, $Bild, $Position[0], $Position[1], $Position2[0] - $Position[0], $Position2[1] - $Position[1])
			EndSwitch
			_GDIPlus_GraphicsDrawImage($Grafik, $Bitmap, 0, 0)
		WEnd
		If $Position[0] <> $Position2[0] And $Position[1] <> $Position2[1] Or $Typ = "DrawString" Or $Typ = "DrawImage" Then
			$Hauptzaehler += 1
			ReDim $Grafiken[$Hauptzaehler][30]
			$Rueckgabe = Zaehler($Typ)
			$Grafiken[$Hauptzaehler - 1][$GRAPHIC_TYPE] = $Typ
			$Grafiken[$Hauptzaehler - 1][$GRAPHIC_NAME] = $Typ & $Rueckgabe
			$Grafiken[$Hauptzaehler - 1][$GRAPHIC_ITEM] = GUICtrlCreateTreeViewItem($Grafiken[$Hauptzaehler - 1][$GRAPHIC_NAME], $TreeView_Objektliste)
			GUICtrlSetImage(-1, $Bilddatei1, 0)
			Switch $Typ
				Case "DrawLine"
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_X1] = $Position[0]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_Y1] = $Position[1]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_X2] = $Position2[0]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_Y2] = $Position2[1]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_PENCOLOR] = $PENCOLOR
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_PENWIDTH] = $PENWIDTH
				Case "DrawRect"
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_X1] = $Position[0]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_Y1] = $Position[1]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_WIDTH] = $Position2[0] - $Position[0]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_HEIGHT] = $Position2[1] - $Position[1]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_PENCOLOR] = $PENCOLOR
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_PENWIDTH] = $PENWIDTH
				Case "FillRect"
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_X1] = $Position[0]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_Y1] = $Position[1]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_WIDTH] = $Position2[0] - $Position[0]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_HEIGHT] = $Position2[1] - $Position[1]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_BRUSHCOLOR] = $BRUSHCOLOR
				Case "FillEllipse"
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_X1] = $Position[0]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_Y1] = $Position[1]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_WIDTH] = $Position2[0] - $Position[0]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_HEIGHT] = $Position2[1] - $Position[1]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_BRUSHCOLOR] = $BRUSHCOLOR
				Case "DrawEllipse"
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_X1] = $Position[0]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_Y1] = $Position[1]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_WIDTH] = $Position2[0] - $Position[0]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_HEIGHT] = $Position2[1] - $Position[1]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_PENCOLOR] = $PENCOLOR
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_PENWIDTH] = $PENWIDTH
				Case "DrawPie"
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_STARTANGLE] = $STARTANGLE
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_SWEEPANGLE] = $SWEEPANGLE
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_X1] = $Position[0]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_Y1] = $Position[1]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_WIDTH] = $Position2[0] - $Position[0]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_HEIGHT] = $Position2[1] - $Position[1]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_PENCOLOR] = $PENCOLOR
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_PENWIDTH] = $PENWIDTH
				Case "DrawArc"
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_STARTANGLE] = $STARTANGLE
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_SWEEPANGLE] = $SWEEPANGLE
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_X1] = $Position[0]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_Y1] = $Position[1]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_WIDTH] = $Position2[0] - $Position[0]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_HEIGHT] = $Position2[1] - $Position[1]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_PENCOLOR] = $PENCOLOR
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_PENWIDTH] = $PENWIDTH
				Case "DrawBezier"
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_X1] = $Points[0][1]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_Y1] = $Points[0][1]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_X2] = $Points[1][1]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_Y2] = $Points[1][1]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_X3] = $Points[2][0]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_Y3] = $Points[2][1]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_X4] = $Points[3][0]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_Y4] = $Points[3][1]
				Case "DrawString"
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_X2] = $Position2[0]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_Y2] = $Position2[1]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_STRING] = $String
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_FONT] = $Font
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_SIZE] = $Size
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_FORMAT] = $Format
				Case "DrawImage"
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_X2] = $Position2[0]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_Y2] = $Position2[1]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_PATH] = $Bilder[$Bildzaehler - 1][1]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_IMAGE] = $Bild
				Case "DrawImageRect"
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_PATH] = $Bilder[$Bildzaehler - 1][1]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_IMAGE] = $Bild
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_X1] = $Position[0]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_Y1] = $Position[1]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_WIDTH] = $Position2[0] - $Position[0]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_HEIGHT] = $Position2[1] - $Position[1]
				Case "FillPie"
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_STARTANGLE] = $STARTANGLE
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_SWEEPANGLE] = $SWEEPANGLE
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_X1] = $Position[0]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_Y1] = $Position[1]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_WIDTH] = $Position2[0] - $Position[0]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_HEIGHT] = $Position2[1] - $Position[1]
					$Grafiken[$Hauptzaehler - 1][$GRAPHIC_BRUSHCOLOR] = $BRUSHCOLOR
			EndSwitch
			If $Sichtbar = "" Then
				$Sichtbar = False
				GUICtrlSetState($MenuItem_ObjektAusschneiden, 64)
				GUICtrlSetState($MenuItem_ObjektKopieren, 64)
				GUICtrlSetState($MenuItem_ObjektEinfuegen, 64)
				GUICtrlSetState($MenuItem_ObjektLoeschen, 64)
			EndIf
			If GUICtrlRead($Edit_Quelltext) <> Quelltext() Then GUICtrlSetData($Edit_Quelltext, Quelltext())
		EndIf
	EndIf
	Malen()
	_GDIPlus_GraphicsDrawImage($Grafik, $Bitmap, 0, 0)
WEnd

_GDIPlus_BrushDispose($Brush)
_GDIPlus_PenDispose($Pen)
_GDIPlus_BitmapDispose($Bitmap)
_GDIPlus_GraphicsDispose($Grafik)
_GDIPlus_Shutdown()
Exit

Func ZeigenVerstecken($Eingabe, $Eingabe2, $Eingabe3)
	If $Eingabe2 = 65 Then
		GUICtrlSetState($Eingabe3, 4)
		GUISetState(@SW_HIDE, $Eingabe)
	Else
		GUICtrlSetState($Eingabe3, 1)
		GUISetState(@SW_SHOW, $Eingabe)
	EndIf
EndFunc   ;==>ZeigenVerstecken

Func Starten()
	FileOpen("temp.au3", 2)
	FileWrite("temp.au3", Quelltext())
	ShellExecute("temp.au3")
EndFunc   ;==>Starten

Func Quelltext()
	Local $IMAGE_INCLUDE = ""
	Local $LAST_PENCOLOR = 4278190080
	Local $LAST_PENWIDTH = 1
	Local $LAST_BRUSHCOLOR = 4278190080
	Local $LAST_PATH = ""
	Local $Rueckgabe = ""
	For $i = 0 To UBound($Grafiken) - 1
		If $Grafiken[$i][$GRAPHIC_TYPE] = "DrawImage" Or $Grafiken[$i][$GRAPHIC_TYPE] = "DrawImageRect" And $LAST_PATH <> $Grafiken[$i][$GRAPHIC_PATH] Then
			$IMAGE_INCLUDE &= @CRLF & '$' & $Grafiken[$i][$GRAPHIC_IMAGE] & ' = _GDIPlus_ImageLoadFromFile("' & $Grafiken[$i][$GRAPHIC_PATH] & '")'
			$LAST_PATH = $Grafiken[$i][$GRAPHIC_PATH]
		EndIf
		If $Grafiken[$i][$GRAPHIC_PENCOLOR] <> $LAST_PENCOLOR Then
			$PENCOLOR = @TAB & "_GDIPlus_PenSetColor($Pen, " & $Grafiken[$i][$GRAPHIC_PENCOLOR] & ")" & @CRLF
			$LAST_PENCOLOR = $Grafiken[$i][$GRAPHIC_PENCOLOR]
		Else
			$PENCOLOR = ""
		EndIf
		If $Grafiken[$i][$GRAPHIC_PENWIDTH] <> $LAST_PENWIDTH Then
			$PENWIDTH = @TAB & "_GDIPlus_PenSetWidth($Pen," & $Grafiken[$i][$GRAPHIC_PENWIDTH] & ")" & @CRLF
			$LAST_PENWIDTH = $Grafiken[$i][$GRAPHIC_PENWIDTH]
		Else
			$PENWIDTH = ""
		EndIf
		If $Grafiken[$i][$GRAPHIC_BRUSHCOLOR] <> $LAST_BRUSHCOLOR Then
			$BRUSHCOLOR = @TAB & "_GDIPlus_BrushSetFillColor($Brush, " & $Grafiken[$i][$GRAPHIC_BRUSHCOLOR] & ")" & @CRLF
			$LAST_BRUSHCOLOR = $Grafiken[$i][$GRAPHIC_BRUSHCOLOR]
		Else
			$BRUSHCOLOR = ""
		EndIf
		$Text = StringReplace($Grafiken[$i][$GRAPHIC_STRING], @CRLF, '"&@CRLF&"')
		Switch $Grafiken[$i][$GRAPHIC_TYPE]
			Case "DrawLine"
				$Rueckgabe &= $PENCOLOR & $PENWIDTH & @TAB & "_GDIPlus_GraphicsDrawLine($Buffer," & $Grafiken[$i][$GRAPHIC_X1] & "," & $Grafiken[$i][$GRAPHIC_Y1] & "," & $Grafiken[$i][$GRAPHIC_X2] & "," & $Grafiken[$i][$GRAPHIC_Y2] & ", $Pen)" & @CRLF
			Case "DrawRect"
				$Rueckgabe &= $PENCOLOR & $PENWIDTH & @TAB & "_GDIPlus_GraphicsDrawRect($Buffer," & $Grafiken[$i][$GRAPHIC_X1] & "," & $Grafiken[$i][$GRAPHIC_Y1] & "," & $Grafiken[$i][$GRAPHIC_WIDTH] & "," & $Grafiken[$i][$GRAPHIC_HEIGHT] & ", $Pen)" & @CRLF
			Case "FillRect"
				$Rueckgabe &= $BRUSHCOLOR & @TAB & "_GDIPlus_GraphicsFillRect($Buffer," & $Grafiken[$i][$GRAPHIC_X1] & "," & $Grafiken[$i][$GRAPHIC_Y1] & "," & $Grafiken[$i][$GRAPHIC_WIDTH] & "," & $Grafiken[$i][$GRAPHIC_HEIGHT] & ", $Brush)" & @CRLF
			Case "DrawEllipse"
				$Rueckgabe &= $PENCOLOR & $PENWIDTH & @TAB & "_GDIPlus_GraphicsDrawEllipse($Buffer," & $Grafiken[$i][$GRAPHIC_X1] & "," & $Grafiken[$i][$GRAPHIC_Y1] & "," & $Grafiken[$i][$GRAPHIC_WIDTH] & "," & $Grafiken[$i][$GRAPHIC_HEIGHT] & ", $Pen)" & @CRLF
			Case "FillEllipse"
				$Rueckgabe &= $BRUSHCOLOR & @TAB & "_GDIPlus_GraphicsFillEllipse($Buffer," & $Grafiken[$i][$GRAPHIC_X1] & "," & $Grafiken[$i][$GRAPHIC_Y1] & "," & $Grafiken[$i][$GRAPHIC_WIDTH] & "," & $Grafiken[$i][$GRAPHIC_HEIGHT] & ", $Brush)" & @CRLF
			Case "DrawPie"
				$Rueckgabe &= $PENCOLOR & $PENWIDTH & @TAB & "_GDIPlus_GraphicsDrawPie($Buffer," & $Grafiken[$i][$GRAPHIC_X1] & "," & $Grafiken[$i][$GRAPHIC_Y1] & "," & $Grafiken[$i][$GRAPHIC_WIDTH] & "," & $Grafiken[$i][$GRAPHIC_HEIGHT] & "," & $Grafiken[$i][$GRAPHIC_STARTANGLE] & "," & $Grafiken[$i][$GRAPHIC_SWEEPANGLE] & ", $Pen)" & @CRLF
			Case "FillPie"
				$Rueckgabe &= $BRUSHCOLOR & @TAB & "_GDIPlus_GraphicsFillPie($Buffer," & $Grafiken[$i][$GRAPHIC_X1] & "," & $Grafiken[$i][$GRAPHIC_Y1] & "," & $Grafiken[$i][$GRAPHIC_WIDTH] & "," & $Grafiken[$i][$GRAPHIC_HEIGHT] & "," & $Grafiken[$i][$GRAPHIC_STARTANGLE] & "," & $Grafiken[$i][$GRAPHIC_SWEEPANGLE] & ", $Brush)" & @CRLF
			Case "DrawArc"
				$Rueckgabe &= $PENCOLOR & $PENWIDTH & @TAB & "_GDIPlus_GraphicsDrawArc($Buffer," & $Grafiken[$i][$GRAPHIC_X1] & "," & $Grafiken[$i][$GRAPHIC_Y1] & "," & $Grafiken[$i][$GRAPHIC_WIDTH] & "," & $Grafiken[$i][$GRAPHIC_HEIGHT] & "," & $Grafiken[$i][$GRAPHIC_STARTANGLE] & "," & $Grafiken[$i][$GRAPHIC_SWEEPANGLE] & ", $Pen)" & @CRLF
			Case "DrawBezier"
				$Rueckgabe &= $PENCOLOR & $PENWIDTH & @TAB & "_GDIPlus_GraphicsDrawBezier($Buffer," & $Grafiken[$i][$GRAPHIC_X1] & "," & $Grafiken[$i][$GRAPHIC_Y1] & "," & $Grafiken[$i][$GRAPHIC_X2] & "," & $Grafiken[$i][$GRAPHIC_Y2] & "," & $Grafiken[$i][$GRAPHIC_X3] & "," & $Grafiken[$i][$GRAPHIC_Y3] & "," & $Grafiken[$i][$GRAPHIC_X4] & "," & $Grafiken[$i][$GRAPHIC_Y4] & ", $Pen)" & @CRLF
			Case "DrawString"
				$Rueckgabe &= @TAB & '_GDIPlus_GraphicsDrawString($Buffer,"' & $Text & '",' & $Grafiken[$i][$GRAPHIC_X2] & "," & $Grafiken[$i][$GRAPHIC_Y2] & ',"' & $Grafiken[$i][$GRAPHIC_FONT] & '",' & $Grafiken[$i][$GRAPHIC_SIZE] & "," & $Grafiken[$i][$GRAPHIC_FORMAT] & ")" & @CRLF
			Case "DrawImage"
				$Rueckgabe &= @TAB & '_GDIPlus_GraphicsDrawImage($Buffer,$' & $Grafiken[$i][$GRAPHIC_IMAGE] & ',' & $Grafiken[$i][$GRAPHIC_X2] & "," & $Grafiken[$i][$GRAPHIC_Y2] & ")" & @CRLF
			Case "DrawImageRect"
				$Rueckgabe &= @TAB & '_GDIPlus_GraphicsDrawImageRect($Buffer,$' & $Grafiken[$i][$GRAPHIC_IMAGE] & ',' & $Grafiken[$i][$GRAPHIC_X1] & "," & $Grafiken[$i][$GRAPHIC_Y1] & ',' & $Grafiken[$i][$GRAPHIC_WIDTH] & ',' & $Grafiken[$i][$GRAPHIC_HEIGHT] & ")" & @CRLF
		EndSwitch
	Next
	$Rueckgabe &= @TAB & "_GDIPlus_PenSetColor($Pen,0xFF000000)" & @CRLF
	$Rueckgabe &= @TAB & "_GDIPlus_PenSetWidth($Pen,1)" & @CRLF
	$Rueckgabe &= @TAB & "_GDIPlus_BrushSetFillColor($Brush,0xFF000000)" & @CRLF
	Return "#include <GDIP.au3>" & @CRLF & @CRLF & 'Global $Title = "' & $Programm[0] & '"' & @CRLF & "Global $Width = " & $Programm[1] & @CRLF & "Global $Height = " & $Programm[2] & "" & @CRLF & @CRLF & "$Form = GUICreate($Title, $Width, $Height)" & @CRLF & "_GDIPlus_Startup()" & $IMAGE_INCLUDE & @CRLF & "$Graphics = _GDIPlus_GraphicsCreateFromHWND($Form)" & @CRLF & "$Bitmap = _GDIPlus_BitmapCreateFromGraphics($Width, $Height, $Graphics)" & @CRLF & "$Buffer = _GDIPlus_ImageGetGraphicsContext($Bitmap)" & @CRLF & "$Pen = _GDIPlus_PenCreate()" & @CRLF & "$Brush = _GDIPlus_BrushCreateSolid()" & @CRLF & "GUISetState()" & @CRLF & @CRLF & "While GUIGetMsg() <> -3" & @CRLF & @TAB & "_GDIPlus_GraphicsClear($Buffer, " & $Programm[3] & ")" & @CRLF & @TAB & @CRLF & $Rueckgabe & @TAB & @CRLF & @TAB & "_GDIPlus_GraphicsDrawImage($Graphics, $Bitmap, 0, 0)" & @CRLF & "WEnd" & @CRLF & @CRLF & "_GDIPlus_BrushDispose($Brush)" & @CRLF & "_GDIPlus_PenDispose($Pen)" & @CRLF & "_GDIPlus_BitmapDispose($Bitmap)" & @CRLF & "_GDIPlus_GraphicsDispose($Graphics)" & @CRLF & "_GDIPlus_Shutdown()" & @CRLF & "Exit"
EndFunc   ;==>Quelltext

Func Malen()
	For $i = 0 To UBound($Grafiken) - 1
		If $Msg = $Grafiken[$i][$GRAPHIC_ITEM] And Aktuell(GUICtrlRead($TreeView_Objektliste, 1)) <> $Aktuell Then ObjektLaden(GUICtrlRead($TreeView_Objektliste, 1))
		_GDIPlus_PenSetColor($Pen, $Grafiken[$i][$GRAPHIC_PENCOLOR])
		_GDIPlus_PenSetWidth($Pen, $Grafiken[$i][$GRAPHIC_PENWIDTH])
		_GDIPlus_BrushSetFillColor($Brush, $Grafiken[$i][$GRAPHIC_BRUSHCOLOR])
		Switch $Grafiken[$i][$GRAPHIC_TYPE]
			Case "DrawLine"
				_GDIPlus_GraphicsDrawLine($Buffer, $Grafiken[$i][$GRAPHIC_X1], $Grafiken[$i][$GRAPHIC_Y1], $Grafiken[$i][$GRAPHIC_X2], $Grafiken[$i][$GRAPHIC_Y2], $Pen)
			Case "DrawRect"
				_GDIPlus_GraphicsDrawRect($Buffer, $Grafiken[$i][$GRAPHIC_X1], $Grafiken[$i][$GRAPHIC_Y1], $Grafiken[$i][$GRAPHIC_WIDTH], $Grafiken[$i][$GRAPHIC_HEIGHT], $Pen)
			Case "FillRect"
				_GDIPlus_GraphicsFillRect($Buffer, $Grafiken[$i][$GRAPHIC_X1], $Grafiken[$i][$GRAPHIC_Y1], $Grafiken[$i][$GRAPHIC_WIDTH], $Grafiken[$i][$GRAPHIC_HEIGHT], $Brush)
			Case "DrawEllipse"
				_GDIPlus_GraphicsDrawEllipse($Buffer, $Grafiken[$i][$GRAPHIC_X1], $Grafiken[$i][$GRAPHIC_Y1], $Grafiken[$i][$GRAPHIC_WIDTH], $Grafiken[$i][$GRAPHIC_HEIGHT], $Pen)
			Case "FillEllipse"
				_GDIPlus_GraphicsFillEllipse($Buffer, $Grafiken[$i][$GRAPHIC_X1], $Grafiken[$i][$GRAPHIC_Y1], $Grafiken[$i][$GRAPHIC_WIDTH], $Grafiken[$i][$GRAPHIC_HEIGHT], $Brush)
			Case "DrawPie"
				_GDIPlus_GraphicsDrawPie($Buffer, $Grafiken[$i][$GRAPHIC_X1], $Grafiken[$i][$GRAPHIC_Y1], $Grafiken[$i][$GRAPHIC_WIDTH], $Grafiken[$i][$GRAPHIC_HEIGHT], $Grafiken[$i][$GRAPHIC_STARTANGLE], $Grafiken[$i][$GRAPHIC_SWEEPANGLE], $Pen)
			Case "FillPie"
				_GDIPlus_GraphicsFillPie($Buffer, $Grafiken[$i][$GRAPHIC_X1], $Grafiken[$i][$GRAPHIC_Y1], $Grafiken[$i][$GRAPHIC_WIDTH], $Grafiken[$i][$GRAPHIC_HEIGHT], $Grafiken[$i][$GRAPHIC_STARTANGLE], $Grafiken[$i][$GRAPHIC_SWEEPANGLE], $Brush)
			Case "DrawArc"
				_GDIPlus_GraphicsDrawArc($Buffer, $Grafiken[$i][$GRAPHIC_X1], $Grafiken[$i][$GRAPHIC_Y1], $Grafiken[$i][$GRAPHIC_WIDTH], $Grafiken[$i][$GRAPHIC_HEIGHT], $Grafiken[$i][$GRAPHIC_STARTANGLE], $Grafiken[$i][$GRAPHIC_SWEEPANGLE], $Pen)
			Case "DrawBezier"
				_GDIPlus_GraphicsDrawBezier($Buffer, $Grafiken[$i][$GRAPHIC_X1], $Grafiken[$i][$GRAPHIC_Y1], $Grafiken[$i][$GRAPHIC_X2], $Grafiken[$i][$GRAPHIC_Y2], $Grafiken[$i][$GRAPHIC_X3], $Grafiken[$i][$GRAPHIC_Y3], $Grafiken[$i][$GRAPHIC_X4], $Grafiken[$i][$GRAPHIC_Y4], $Pen)
			Case "DrawString"
				_GDIPlus_GraphicsDrawString($Buffer, $Grafiken[$i][$GRAPHIC_STRING], $Grafiken[$i][$GRAPHIC_X2], $Grafiken[$i][$GRAPHIC_Y2], $Grafiken[$i][$GRAPHIC_FONT], $Grafiken[$i][$GRAPHIC_SIZE], $Grafiken[$i][$GRAPHIC_FORMAT])
			Case "DrawImage"
				_GDIPlus_GraphicsDrawImage($Buffer, $Grafiken[$i][$GRAPHIC_IMAGE], $Grafiken[$i][$GRAPHIC_X2], $Grafiken[$i][$GRAPHIC_Y2])
			Case "DrawImageRect"
				_GDIPlus_GraphicsDrawImageRect($Buffer, $Grafiken[$i][$GRAPHIC_IMAGE], $Grafiken[$i][$GRAPHIC_X1], $Grafiken[$i][$GRAPHIC_Y1], $Grafiken[$i][$GRAPHIC_WIDTH], $Grafiken[$i][$GRAPHIC_HEIGHT])
		EndSwitch
	Next
EndFunc   ;==>Malen

Func Oeffnen()
	Local $Pfad = FileOpenDialog("Datei ffnen", "", "GDI Editor Datei (*.gef)", 1 + 2)
	If Not @error Then
		$Speicherpfad = $Pfad
		StreamVonDatei($Speicherpfad)
	EndIf
EndFunc   ;==>Oeffnen

Func Neu()
	If UBound($Grafiken) >= 1 Then
		$MsgBox = MsgBox(36, "GDIPlus Editor", "Mchten sie wirklich die Objekte lschen")
		If $MsgBox = 6 Then
			$Speicherpfad = ""
			StreamLoeschen()
		EndIf
	EndIf
EndFunc   ;==>Neu

Func Speichern()
	If $Speicherpfad <> "" Then
		StreamZuDatei($Speicherpfad)
	Else
		SpeichernUnter()
	EndIf
EndFunc   ;==>Speichern

Func SpeichernUnter()
	Local $Pfad = FileSaveDialog("Datei speichern", "", "GDIPlus Editor Datei (*.gef)", 2)
	If Not @error Then
		If StringRight($Pfad, 3) = "gef" Then
			$Speicherpfad = $Pfad
			StreamZuDatei($Speicherpfad)
		Else
			$Speicherpfad = $Pfad & ".gef"
			StreamZuDatei($Speicherpfad)
		EndIf
	EndIf
EndFunc   ;==>SpeichernUnter

Func StreamZuDatei($Eingabe)
	Local $String = ""
	For $a = 0 To UBound($Grafiken) - 1
		For $b = 0 To 29
			$String &= $Grafiken[$a][$b] & ""
		Next
		$String &= "^"
	Next
	Local $Datei = FileOpen($Eingabe, 2)
	FileWrite($Datei, $String)
	FileClose($Datei)
EndFunc   ;==>StreamZuDatei

Func StreamVonDatei($Eingabe)
	StreamLoeschen()
	Local $Datei = FileOpen($Eingabe)
	Local $DateiLesen = FileRead($Datei)
	FileClose($Datei)
	Local $StringSplit = StringSplit($DateiLesen, "^")
	For $a = 1 To $StringSplit[0] - 1
		$StringSplit2 = StringSplit($StringSplit[$a], "")
		$Rueckgabe = Registrieren($StringSplit2)
		If $StringSplit2[1] = "DrawImage" Or $StringSplit2[1] = "DrawImageRect" Then
			$Bildzaehler += 1
			ReDim $Bilder[$Bildzaehler][2]
			$Bilder[$Bildzaehler - 1][0] = _GDIPlus_ImageLoadFromFile($StringSplit2[22])
			$Bilder[$Bildzaehler - 1][1] = $StringSplit2[22]
			$Bild = $Bilder[$Bildzaehler - 1][0]
			$Grafiken[$Rueckgabe][$GRAPHIC_IMAGE] = $Bilder[$Bildzaehler - 1][0]
		EndIf
	Next
	GUICtrlSetData($Edit_Quelltext, Quelltext())
EndFunc   ;==>StreamVonDatei

Func StreamLoeschen()
	For $a = 0 To UBound($Grafiken) - 1
		GUICtrlDelete($Grafiken[$a][$GRAPHIC_ITEM])
	Next
	Dim $Grafiken[1][30]
	GUICtrlSetData($Edit_Quelltext, "")
	Dim $Grafiken[1][30]
	Dim $Zwischenspeicher[31]
	Dim $Bilder[1][2]
	Dim $Programm[4]
	Dim $Zaehler[12]
	Global $Hauptzaehler = 0
	Global $Bildzaehler = 0
	Global $Typ = "DrawLine"
	Global $Speicherpfad = ""
	Global $String, $Font, $Size, $Format, $Bild, $Msg, $Sichtbar
	Global $Aktuell = 0
	$Programm[0] = "Example"
	$Programm[1] = 700
	$Programm[2] = 500
	$Programm[3] = "0xFFFFFFFF"
	FormAendern()
EndFunc   ;==>StreamLoeschen

Func Text()
	Local $Form_Text_einfuegen = GUICreate("Text einfgen", 242, 220)
	GUISetFont(10, 400, 0, "Verdana")
	GUICtrlCreateLabel("Text", 8, 10, 34, 20)
	GUICtrlCreateLabel("Schrift", 8, 92, 34, 20)
	GUICtrlCreateLabel("Schriftgre", 8, 124, 31, 20)
	GUICtrlCreateLabel("Format", 8, 156, 50, 20)
	Local $Input_Text = GUICtrlCreateEdit("Text", 96, 8, 137, 74)
	Local $Input_Schrift = GUICtrlCreateCombo("Arial", 96, 90, 137, 25, 0x3)
	GUICtrlSetData(-1, "Courier New|Lucida Console|Tahoma|Times New Roman|Verdana|Trebuchet MS|Georgia|Comic Sans MS")
	Local $Input_Schriftgroesze = GUICtrlCreateInput("10", 96, 122, 137, 24, 2048)
	GUICtrlCreateUpdown($Input_Schriftgroesze)
	GUICtrlSetLimit(-1, 1000, 6)
	Local $Input_Format = GUICtrlCreateCombo("0x0000", 96, 154, 137, 25, 0x3)
	GUICtrlSetData(-1, "0x0001|0x0002|0x0004|0x0020|0x0400|0x0800|0x1000|0x2000|0x4000")
	Local $Button_OK = GUICtrlCreateButton("OK", 80, 186, 75, 25)
	Local $Button_Abbrechen = GUICtrlCreateButton("Abbrechen", 160, 186, 75, 25)
	GUISetState()
	While True
		Switch GUIGetMsg()
			Case -3
				GUIDelete($Form_Text_einfuegen)
				ExitLoop
			Case $Button_Abbrechen
				GUIDelete($Form_Text_einfuegen)
				ExitLoop
			Case $Button_OK
				Local $Lese = GUICtrlRead($Input_Text)
				Local $Lese2 = GUICtrlRead($Input_Schrift)
				Local $Lese3 = GUICtrlRead($Input_Schriftgroesze)
				Local $Lese4 = GUICtrlRead($Input_Format)
				$String = $Lese
				$Font = $Lese2
				$Size = $Lese3
				$Format = $Lese4
				GUIDelete($Form_Text_einfuegen)
				ExitLoop
		EndSwitch
	WEnd
	If $String <> "" Then Assign("Typ", "DrawString")
EndFunc   ;==>Text

Func Bild($Eingabe)
	Local $Pfad = FileOpenDialog("GDI Editor", "", "Bilder (*.jpg;*.bmp;*.png;*.gif;*.tif)", 1 + 2)
	If Not @error Then
		$Bildzaehler += 1
		ReDim $Bilder[$Bildzaehler][2]
		$Bilder[$Bildzaehler - 1][0] = _GDIPlus_ImageLoadFromFile($Pfad)
		$Bilder[$Bildzaehler - 1][1] = $Pfad
		$Bild = $Bilder[$Bildzaehler - 1][0]
		Assign("Typ", $Eingabe)
	EndIf
EndFunc   ;==>Bild

Func FormAendern()
	GUIDelete($Form_Form)
	$Form_Form = GUICreate("Form", $Programm[1], $Programm[2], 190, 92, -1, -1, $Form_GDI_Editor)
	$Grafik = _GDIPlus_GraphicsCreateFromHWND($Form_Form)
	$Bitmap = _GDIPlus_BitmapCreateFromGraphics($Programm[1], $Programm[2], $Grafik)
	$Buffer = _GDIPlus_ImageGetGraphicsContext($Bitmap)
	GUISetState()
EndFunc   ;==>FormAendern

Func ObjektAusschneiden($Objekt)
	ObjektKopieren($Objekt)
	ObjektLoeschen($Objekt)
EndFunc   ;==>ObjektAusschneiden
Func ObjektKopieren($Objekt)
	Local $Rueckgabe = ""
	For $a = 0 To UBound($Grafiken) - 1
		If $Objekt = $Grafiken[$a][$GRAPHIC_NAME] Then
			$Rueckgabe = $a
		EndIf
	Next
	For $b = 0 To 29
		$Zwischenspeicher[$b + 1] = $Grafiken[$Rueckgabe][$b]
	Next
EndFunc   ;==>ObjektKopieren

Func ObjektEinfuegen()
	Registrieren($Zwischenspeicher)
EndFunc   ;==>ObjektEinfuegen

Func ObjektLaden($Objekt)
	Local $Rueckgabe = ""
	For $a = 0 To UBound($Grafiken) - 1
		If $Objekt = $Grafiken[$a][$GRAPHIC_NAME] Then
			$Rueckgabe = $a
		EndIf
	Next
	GUICtrlSetData($Steuerung[$GRAPHIC_FONT], "Courier New|Lucida Console|Tahoma|Times New Roman|Verdana|Trebuchet MS|Georgia|Comic Sans MS")
	GUICtrlSetData($Steuerung[$GRAPHIC_FORMAT], "0x0001|0x0002|0x0004|0x0020|0x0400|0x0800|0x1000|0x2000|0x4000")
	For $b = 0 To 29
		GUICtrlSetState($Steuerung[$b], 64)
		GUICtrlSetData($Steuerung[$b], $Grafiken[$Rueckgabe][$b])
		If $Grafiken[$Rueckgabe][$b] = "" Then GUICtrlSetState($Steuerung[$b], 128)
	Next
	$Aktuell = $Rueckgabe
EndFunc   ;==>ObjektLaden

Func ObjektLoeschen($Objekt)
	Local $Rueckgabe = ""
	For $a = 0 To UBound($Grafiken) - 1
		If $Objekt = $Grafiken[$a][$GRAPHIC_NAME] Then
			$Rueckgabe = $a
		EndIf
	Next
	GUICtrlDelete($Grafiken[$Rueckgabe][$GRAPHIC_ITEM])
	$Hauptzaehler -= 1
	_ArrayDelete($Grafiken,$Rueckgabe)
	GUICtrlSetData($Edit_Quelltext,Quelltext())
EndFunc   ;==>ObjektLoeschen

Func Aktuell($Objekt)
	Local $Rueckgabe = ""
	For $a = 0 To UBound($Grafiken) - 1
		If $Objekt = $Grafiken[$a][$GRAPHIC_NAME] Then
			$Rueckgabe = $a
		EndIf
	Next
	Return $Rueckgabe
EndFunc   ;==>Aktuell

Func Registrieren($Eingabe)
	Local $Rueckgabe = ""
	$Hauptzaehler += 1
	ReDim $Grafiken[$Hauptzaehler][30]
	$Rueckgabe = Zaehler($Eingabe[1])
	$Grafiken[$Hauptzaehler - 1][$GRAPHIC_TYPE] = $Eingabe[1]
	$Grafiken[$Hauptzaehler - 1][$GRAPHIC_NAME] = $Eingabe[1] & $Rueckgabe
	$Grafiken[$Hauptzaehler - 1][$GRAPHIC_X1] = $Eingabe[2]
	$Grafiken[$Hauptzaehler - 1][$GRAPHIC_Y1] = $Eingabe[3]
	$Grafiken[$Hauptzaehler - 1][$GRAPHIC_X2] = $Eingabe[4]
	$Grafiken[$Hauptzaehler - 1][$GRAPHIC_Y2] = $Eingabe[5]
	$Grafiken[$Hauptzaehler - 1][$GRAPHIC_WIDTH] = $Eingabe[6]
	$Grafiken[$Hauptzaehler - 1][$GRAPHIC_HEIGHT] = $Eingabe[7]
	$Grafiken[$Hauptzaehler - 1][$GRAPHIC_PENCOLOR] = $Eingabe[8]
	$Grafiken[$Hauptzaehler - 1][$GRAPHIC_PENWIDTH] = $Eingabe[9]
	$Grafiken[$Hauptzaehler - 1][$GRAPHIC_BRUSHCOLOR] = $Eingabe[10]
	$Grafiken[$Hauptzaehler - 1][$GRAPHIC_STARTANGLE] = $Eingabe[11]
	$Grafiken[$Hauptzaehler - 1][$GRAPHIC_SWEEPANGLE] = $Eingabe[12]
	$Grafiken[$Hauptzaehler - 1][$GRAPHIC_X3] = $Eingabe[13]
	$Grafiken[$Hauptzaehler - 1][$GRAPHIC_Y3] = $Eingabe[14]
	$Grafiken[$Hauptzaehler - 1][$GRAPHIC_X4] = $Eingabe[15]
	$Grafiken[$Hauptzaehler - 1][$GRAPHIC_Y4] = $Eingabe[16]
	$Grafiken[$Hauptzaehler - 1][$GRAPHIC_STRING] = $Eingabe[17]
	$Grafiken[$Hauptzaehler - 1][$GRAPHIC_FONT] = $Eingabe[18]
	$Grafiken[$Hauptzaehler - 1][$GRAPHIC_SIZE] = $Eingabe[19]
	$Grafiken[$Hauptzaehler - 1][$GRAPHIC_FORMAT] = $Eingabe[20]
	$Grafiken[$Hauptzaehler - 1][$GRAPHIC_IMAGE] = $Eingabe[21]
	$Grafiken[$Hauptzaehler - 1][$GRAPHIC_PATH] = $Eingabe[22]
	$Grafiken[$Hauptzaehler - 1][$GRAPHIC_ITEM] = GUICtrlCreateTreeViewItem($Eingabe[1] & $Rueckgabe, $TreeView_Objektliste)
	GUICtrlSetImage(-1, $Bilddatei1, 0)
	$Rueckgabe = $Hauptzaehler - 1
	Return $Rueckgabe
EndFunc   ;==>Registrieren

Func Zaehler($Eingabe)
	Local $Rueckgabe = ""
	Switch $Eingabe
		Case "DrawLine"
			$Zaehler[0] += 1
			$Rueckgabe = $Zaehler[0]
		Case "DrawRect"
			$Zaehler[1] += 1
			$Rueckgabe = $Zaehler[1]
		Case "FillRect"
			$Zaehler[2] += 1
			$Rueckgabe = $Zaehler[2]
		Case "FillEllipse"
			$Zaehler[3] += 1
			$Rueckgabe = $Zaehler[3]
		Case "DrawPie"
			$Zaehler[4] += 1
			$Rueckgabe = $Zaehler[4]
		Case "DrawArc"
			$Zaehler[5] += 1
			$Rueckgabe = $Zaehler[5]
		Case "DrawBezier"
			$Zaehler[6] += 1
			$Rueckgabe = $Zaehler[6]
		Case "DrawString"
			$Zaehler[7] += 1
			$Rueckgabe = $Zaehler[7]
		Case "DrawImage"
			$Zaehler[8] += 1
			$Rueckgabe = $Zaehler[8]
		Case "DrawImageRect"
			$Zaehler[9] += 1
			$Rueckgabe = $Zaehler[9]
		Case "FillPie"
			$Zaehler[10] += 1
			$Rueckgabe = $Zaehler[10]
		Case "DrawEllipse"
			$Zaehler[11] += 1
			$Rueckgabe = $Zaehler[11]
	EndSwitch
	Return $Rueckgabe
EndFunc   ;==>Zaehler

Func Farbe($Eingabe)
	Local $Rueckgabe = $Eingabe
	$Farbe = _ChooseColor(2, $Eingabe, 2)
	If $Farbe <> -1 Then $Rueckgabe = StringReplace($Farbe, "0x", "0xFF")
	Return $Rueckgabe
EndFunc   ;==>Farbe
